/*
 *	PCE ǾŷȤ鲻ΰڤФ
 *
 *	Copyright (C) 2004	MURAKAMI Tomokazu
 *
 *		http://kikyou.sakura.ne.jp/~tomone/
 *		tomone@kikyou.sakura.ne.jp
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>


#define ON	1
#define OFF	2
#define ERROR	(-1)


#define DEFAULT_OUTPUT_FILEBASE	"output"
#define DEFAULT_SILENCE_LENGTH	8192
#define DEFAULT_OFFSET_POSITION	0

/* ϥեη */
#define DEFAULT_OUTPUT_PLACE	5

/* ̵ɤȽ */
#define issilence(X)	((X)== 0x08 ||(X)== 0x80)

char *input_filename;		/* ϥե̾ */
char *output_filebase;		/* ϥե١̾ */
char *output_filename;		/* ϥե̾ */
int output_filename_lengh;	/* ϥե̾Ĺ */

/* ̵Ĺ */
int silence_length = DEFAULT_SILENCE_LENGTH;

/* ϰ */
int offset_position =  DEFAULT_OFFSET_POSITION;

/* ޷褤⡼ */
int verpose_mode = OFF;

/** **/
static void usage();
void option_analysis();
void release_memory();
void error_end();
void voice_area_output();


void option_analysis(int argc, char **argv)
{
  int c;
	
  while(1){
    c = getopt(argc, argv, "o:l:f:vh");
    if (c == -1)
      break;

    switch(c)
      {
      case 'o':			/* ϥե١̾ */
	output_filebase = strdup(optarg); 
	if(output_filebase == NULL){
	  fprintf(stderr,"Cannot strdup for output filebase.\n");
	  error_end();
	}
	break;

      case 'l' :		/* ̵Ĺ */
	silence_length = atoi(optarg);
	break;

      case 'f' :		/* ϰ */
	offset_position = atoi(optarg);
	break;
	
      case 'v':			/* ޷褤 */
	verpose_mode = ON;
	break;
			
      case 'h':			/* HELP */
	usage();
	break;
		
      default:
	usage();
      }
  }
  if(optind < argc){
    input_filename = strdup(argv[optind]); 
    if( input_filename == NULL){
      fprintf(stderr,"Cannot strdup for input filename.\n");
      error_end();
    }
  }
  if( output_filebase == NULL){
    output_filebase = strdup(DEFAULT_OUTPUT_FILEBASE); 
    if(output_filebase == NULL){
      fprintf(stderr,"Cannot strdup for output filebase.\n");
      error_end();
    }
  }
}

/* char* free() */
void free_char_p(char **p)
{
  if( *p != NULL ){
    free(*p);
    *p = NULL;
  }
}

/*  */
void release_memory()
{
  free_char_p( &input_filename );
  free_char_p( &output_filebase );
  free_char_p( &output_filename );
}

void error_end()
{
  release_memory();
  exit (ERROR);
}

void voice_analysis(FILE *fp)
{
  int c;
  int current_position = 0;	/* ߰ */
  int voice_area_mode = ON;	/* ΰ⡼ */
  int voice_area_start_position = 0; /* ΰ賫ϰ */
  int silence_area_count = 0;	/* Ϣ³̵ʸ */
  int voice_number = 1;		/*  */

  /* եåȰ֤ޤ seek */
  fseek(fp, offset_position, SEEK_SET);
  current_position = offset_position;

  voice_area_start_position = current_position;
  
  while( (c = getc(fp)) != EOF){
    current_position++;

    if( voice_area_mode == ON){	/* ΰˤ */
      if( issilence(c) ){	/* ̵ʸ褿 */
	silence_area_count++;	/* Ϣ³̵ʸ */

	/* Ϣ³̵ʸ¿ */
	if( silence_area_count >= silence_length ){
	  /* ΰڤФ */
	  /*
	  voice_area_output(voice_area_start_position,
			    current_position
			    - voice_area_start_position + 1,
			    voice_number++);
	  */
	  voice_area_output(voice_area_start_position,
			    current_position - silence_area_count
			    - voice_area_start_position + 1,
			    voice_number++);
	  voice_area_mode = OFF; /* ̵ΰˤʤä */
	  silence_area_count = 0; /* Ϣ³̵ʸ */
	}
      }else{			/* ʸ褿 */
	silence_area_count = 0; /* Ϣ³̵ʸ */
      }
    }else{			/* ̵ΰˤ */
      if( !issilence(c) ){	/* ʸ褿 */
	voice_area_start_position = current_position; /* ΰλ */
	voice_area_mode = ON;	/* ΰˤʤä */
      }
    }

  } /* while() END */

  if( voice_area_mode == ON ){	/* EOF ˲ΰ */
    /* ΰڤФ */
    voice_area_output(voice_area_start_position,
		      current_position
		      - voice_area_start_position,
		      voice_number++);
  }

  
}

void voice_area_output(int offset, int size, int number)
{
  FILE *fp;			/* ϥե */
  FILE *gp;			/* ϥե */
  char *buf;
  int i, e;

  if( verpose_mode == ON)
    printf("%d\t%d\t%d\n", number, offset, size);

  /* ϥե̾ */
  for( i = 0 ; i< DEFAULT_OUTPUT_PLACE ; i++){
    output_filename[output_filename_lengh -i -2] = number % 10 + '0';
    number /= 10;
  }

  /* ɤ߽ѥХåե */
  buf = malloc( sizeof(char) * size );
  if( buf == NULL){
    perror("voice_area_output(): cannot malloc output buffer ");
    error_end();
  }

  /* ϥե open */
  fp = fopen( input_filename, "r");
  if( fp == NULL ){
    perror("voice_area_output(): cannot open input file ");
    error_end();
  }
  
  /* ڽФ֤ذư */
  e = fseek(fp, offset, SEEK_SET);
  if( e < 0 ){
    perror("voice_area_output(): cannot fseek input file ");
    error_end();
  }
  /* ΰɤ߹ */
  e = fread( buf, size, 1, fp);
  if( e < 1 ){
    perror("voice_area_output(): cannot read input file ");
    error_end();
  }

  fclose(fp);

  /* ϥե open */
  gp = fopen( output_filename, "w");
  if( gp == NULL ){
    perror("voice_area_output(): cannot open output file ");
    error_end();
  }

  /* 񤭹 */
  e = fwrite( buf, size, 1, gp);
  if( e < 1 ){
    perror("voice_area_output(): cannot write outut file ");
    error_end();
  }

  fclose(gp);

  free(buf);
  
}

int main(int argc, char **argv)
{
  FILE *fp;
	
  /*  */
  option_analysis(argc, argv);

  /* ϥե open */
  if( input_filename == NULL){
    fp = stdin;
  }else{
    fp = fopen( input_filename, "r");
    if( fp == NULL ){
      perror("main(): cannot open input file ");
      error_end();
    }
  }

  /* ϥե̾Ĺ׻ */
  output_filename_lengh =
    strlen(output_filebase) + DEFAULT_OUTPUT_PLACE + 2;

  output_filename = malloc( output_filename_lengh );
  if( output_filename == NULL){
    perror("main(): cannot malloc output_filename ");
    error_end();
  }

  /* ե̾׻ */
  strcpy(output_filename, output_filebase);
  output_filename[strlen(output_filebase)]='.';
  output_filename[output_filename_lengh -1]='\0';

  voice_analysis(fp);

  release_memory();
  exit(0);

}



/* Ȥ */
static void usage()
{
  fprintf(stderr,"pce-da-v-cut [-v] [-[olf] param] file\n");
  fprintf(stderr,"\t-h usage.\n");
  fprintf(stderr,"\t-v verpose.\n");
  fprintf(stderr,"\t-l silence length. (default %d)\n",
	  DEFAULT_SILENCE_LENGTH);
  fprintf(stderr,"\t-f offset. (default %d)\n",
	  DEFAULT_OFFSET_POSITION);
  fprintf(stderr,"\t-o Output file basename.\n");
  
  release_memory();
  exit(0);
}
